/***********
20160830 LBW
***********/
var c,
CanvasBackground = {
    settings: {
        weatherBackground: $('#weather-background'),
        weatherCanvas: $('#weather-canvas')[0],
        weatherCTX: $('#weather-canvas')[0].getContext('2d'),
        rainCanvas: $('#rain-canvas')[0],
        rainCTX: $('#rain-canvas')[0].getContext('2d'),
        cloudCanvas: $('#cloud-canvas')[0],
        cloudCTX: $('#cloud-canvas')[0].getContext('2d'),
        lightningCanvas: $('#lightning-canvas')[0],
        lightningCTX: $('#lightning-canvas')[0].getContext('2d'),
        iconColor: {
            defaultWeather: 'rgba(255,255,255,.3)', //雨点/雪花/云颜色(默认#9AD4E0,系统搭配#9cbcee),此处半透明
            rain: '#63A6CC',
            snow: '#B5B9BB',
            clouds: '#6AB7E3'
        },
        requestRain: '',
        requestCloud: '',
        requestWeather: ''
    },

    init: function (weatherChoose) {
        c = this.settings;
        CanvasBackground.setupCanvas();
        CanvasBackground.chooseBackground(weatherChoose);
    },

    setupCanvas: function () {
        CanvasBackground.resizeBackground();
        window.addEventListener('resize', CanvasBackground.resizeBackground, false);
        window.addEventListener('orientationchange', CanvasBackground.resizeBackground, false);
    },
    resizeBackground: function () {
        /* Resize the canvas to occupy the full page, 
        by getting the widow width and height and setting it to canvas*/

        c.weatherCanvas.width = window.innerWidth;
        c.weatherCanvas.height = window.innerHeight;
        c.rainCanvas.width = window.innerWidth;
        c.rainCanvas.height = window.innerHeight;
        c.cloudCanvas.width = window.innerWidth;
        c.cloudCanvas.height = window.innerHeight;
        c.lightningCanvas.width = window.innerWidth;
        c.lightningCanvas.height = window.innerHeight;
    },
    //天气选择
    chooseBackground: function (weatherChoose) {
        c.weatherBackground.removeClass();
        CanvasBackground.clearAllCanvases();
        c.weatherBackground.addClass('default-weather');
        color_var = c.iconColor.defaultWeather;
        switch (weatherChoose) {
            case 'smallRain':
                CanvasBackground.animateRain('drizzle');
                $("#lightning-canvas").hide();
                $("#lightning-canvas1").hide();
                break;
            case 'rain':
                CanvasBackground.animateRain();
                $("#lightning-canvas").hide();
                $("#lightning-canvas1").hide();
                break;
            case 'Thunderstorm':
                CanvasBackground.animateRain();
                CanvasBackground.animateLightning();
                $("#lightning-canvas").hide();
                $("#lightning-canvas1").hide();
                break;
            case 'snow':
                CanvasBackground.animateSnow();
                $("#lightning-canvas").hide();
                $("#lightning-canvas1").hide();
                break;
            case 'clouds':
                CanvasBackground.animateClouds();
                $("#lightning-canvas").hide();
                $("#lightning-canvas1").hide();
                break;
            case 'sunClouds':
                $(".sunny").show();
                CanvasBackground.animateClouds();
                break;
            case 'sun':
                $(".sunny").show();
                break;
            default:
                break;
        }
    },
    clearAllCanvases: function () {
        cancelAnimationFrame(c.requestRain);
        cancelAnimationFrame(c.requestCloud);
        cancelAnimationFrame(c.requestWeather);
        c.weatherCTX.clearRect(0, 0, c.weatherCanvas.width, c.weatherCanvas.height);
        c.rainCTX.clearRect(0, 0, c.rainCanvas.width, c.rainCanvas.height);
        c.cloudCTX.clearRect(0, 0, c.cloudCanvas.width, c.cloudCanvas.height);
        c.lightningCTX.clearRect(0, 0, c.lightningCanvas.width, c.lightningCanvas.height);
    },

    animateRain: function (condition) {
        var rainSvg = '<svg width="28px" height="39px" viewBox="0 0 28 39" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns"><title>rain</title><desc>Created with Sketch.</desc><defs></defs><g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage"><g id="rain" sketch:type="MSLayerGroup" transform="translate(-10.000000, -6.000000)" fill="' + color_var + '"><g id="Page-1" sketch:type="MSShapeGroup"> <path d="M12,18.2105263 C12.0000002,15.6842105 16,10 16,10 C16,10 20,15.6842105 20,18.2105263 C20,20.3033949 18.2091391,22 16,22 C13.7908609,22 12,20.3033949 12,18.2105263 Z M12,18.2105263" id="Oval 207 copy 2"></path></g></g></g></svg>';


        var rainDrops = [],
            maxSpeed = 10,
            spacing = 20, //雨滴密度
            xSpacing = 0,
            n = innerWidth / spacing,
            sizes = [[58, 139], [54, 63], [50, 58]], //雨滴大小
            i;


        if (condition === 'drizzle') {
            rainSvg = '<svg width="28px" height="39px" viewBox="0 0 28 39" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns"><title>rain</title><desc>Created with Sketch.</desc><defs></defs><g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage"><g id="rain" sketch:type="MSLayerGroup" transform="translate(-10.000000, -6.000000)" fill="' + color_var + '"><g id="Page-1" sketch:type="MSShapeGroup"><path d="M33.5,33.5 C33.5,40.1273333 28.1266667,45.5 21.5,45.5 C14.8726667,45.5 9.5,40.1273333 9.5,33.5 C9.5,21.5 21.5,3.50000001 21.5,3.50000001 C21.5,3.50000001 33.5,21.5 33.5,33.5 L33.5,33.5 L33.5,33.5 Z" id="rain" transform="translate(21.500000, 24.500000) rotate(0.000000) translate(-21.500000, -24.500000) "></path></g></g></g></svg>';
            spacing = 20;
            n = innerWidth / spacing;
            sizes = [[10, 14], [15, 20.8]];
        }

        // Create a Data URI.
        var rainSrc = 'data:image/svg+xml;base64,' + window.btoa(rainSvg);

        // Load up our image.
        var rainSource = new Image();
        rainSource.src = rainSrc;

        for (i = 0; i < n; i++) {
            for (x = 0; x < sizes.length; x++) {
                xSpacing += spacing;
                if (condition === 'drizzle') {
                    rainDrops.push({
                        x: Math.round(Math.random() * c.rainCanvas.width),
                        y: Math.round(Math.random() * c.rainCanvas.height),
                        width: Math.round(Math.random() * (innerWidth / 10)),
                        height: 1,
                        speed: Math.random() * maxSpeed + 2,
                        imgWidth: sizes[x][0],
                        imgHeight: sizes[x][1]
                    });

                } else {
                    rainDrops.push({
                        x: xSpacing,
                        y: Math.round(Math.random() * c.rainCanvas.height),
                        width: 2,
                        height: Math.round(Math.random() * (innerHeight / 10)),
                        speed: Math.random() * maxSpeed + 5,
                        imgWidth: sizes[x][0],
                        imgHeight: sizes[x][1]
                    });
                }

            }

        }

        function draw() {
            var i;
            c.rainCTX.clearRect(0, 0, c.rainCanvas.width, c.rainCanvas.height);

            for (i = 0; i < n; i++) {
                c.rainCTX.drawImage(rainSource, rainDrops[i].x, rainDrops[i].y, rainDrops[i].imgWidth, rainDrops[i].imgHeight);
                if (condition === 'drizzle') {
                    rainDrops[i].y += rainDrops[i].speed;
                    rainDrops[i].x = rainDrops[i].x;
                    if (rainDrops[i].y > c.rainCanvas.height) {
                        rainDrops[i].y = 0 - rainDrops[i].height;
                        rainDrops[i].x = Math.random() * c.rainCanvas.width;
                    }
                } else {
                    rainDrops[i].y += rainDrops[i].speed;
                    rainDrops[i].x += rainDrops[i].speed / 2;
                    if (rainDrops[i].y > c.rainCanvas.height)
                        rainDrops[i].y = 0 - rainDrops[i].height;

                    if (rainDrops[i].x > c.rainCanvas.width)
                        rainDrops[i].x = 0;
                }
            }


            c.requestRain = requestAnimationFrame(draw);

        }
        draw();
    },

    animateClouds: function () {
        var cloudSvg = '<svg width="100px" height="55px" viewBox="0 0 100 55" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns"><title>Group</title><desc>Created with Sketch.</desc><defs></defs><g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage"><g id="cloud" sketch:type="MSLayerGroup" fill="' + color_var + '"><g id="Group" sketch:type="MSShapeGroup"><path d="M83.336,20.018 C81.412,13.644 75.501,9 68.5,9 C66.193,9 64.013,9.518 62.046,10.421 C57.008,4.074 49.232,0 40.5,0 C26.11,0 14.31,11.053 13.108,25.132 C5.719,26.064 0,32.358 0,40 C0,48.284 6.716,55 15,55 L83,55 C92.389,55 100,47.165 100,37.5 C100,27.952 92.568,20.204 83.336,20.018 L83.336,20.018 Z" id="Shape"></path><path d="M15,51 C8.935,51 4,46.065 4,40 C4,34.478 8.131,29.792 13.609,29.101 L16.819,28.696 L17.094,25.473 C18.122,13.432 28.403,4 40.5,4 C47.708,4 54.419,7.247 58.913,12.908 L60.864,15.366 L63.716,14.056 C65.241,13.355 66.851,13 68.5,13 C73.528,13 78.054,16.361 79.507,21.173 L80.347,23.958 L83.255,24.017 C90.283,24.158 96,30.207 96,37.5 C96,44.944 90.168,51 83,51 L15,51 L15,51 Z" id="Shape"></path></g></g></g></svg>';

        // Create a Data URI.
        var cloudSrc = 'data:image/svg+xml;base64,' + window.btoa(cloudSvg);

        // Load up our image.
        var cloudSource = new Image();
        cloudSource.src = cloudSrc;

        var cloudArray = [],
            maxSpeed = 2,
            spacing = 100,
            xSpacing = 0,
            n = innerWidth / spacing,
            sizes = [[100, 55], [90, 49.5], [80, 44]],
            i;

        for (i = 0; i < n; i++) {
            for (x = 0; x < sizes.length; x++) {
                xSpacing += spacing;
                cloudArray.push({
                    x: xSpacing,
                    y: Math.round(Math.random() * c.cloudCanvas.height),
                    width: 2,
                    height: Math.round(Math.random() * (innerHeight / 10)),
                    speed: Math.random() * maxSpeed + 1,
                    imgWidth: sizes[x][0],
                    imgHeight: sizes[x][1],
                    img: cloudSource
                });
            }
        }

        function draw() {
            var i;
            c.cloudCTX.clearRect(0, 0, c.cloudCanvas.width, c.cloudCanvas.height);

            for (i = 0; i < n; i++) {
                c.cloudCTX.drawImage(cloudArray[i].img, cloudArray[i].x, cloudArray[i].y, cloudArray[i].imgWidth, cloudArray[i].imgHeight);
                cloudArray[i].y = cloudArray[i].y;
                cloudArray[i].x += cloudArray[i].speed / 1.5;

                if (cloudArray[i].y > c.cloudCanvas.height)
                    cloudArray[i].y = 0 - cloudArray[i].height;

                if (cloudArray[i].x > c.cloudCanvas.width)
                    cloudArray[i].x = 0 - 100;
            }


            c.requestCloud = requestAnimationFrame(draw);

        }
        draw();
    },

    animateSnow: function () {
        var snowSvg = '<svg width="89px" height="100px" viewBox="0 0 89 100" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns"><title>Shape</title><desc>Created with Sketch.</desc><defs></defs><g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage"><g id="Artboard" sketch:type="MSArtboardGroup" fill="' + color_var + '"><path d="M36.786,50.287 L40.741,56.128 L48.106,56.128 L51.504,50.287 L47.924,44.067 L40.545,44.067 L36.786,50.287 L36.786,50.287 Z M39.819,97.261 L39.819,84.054 L32.44,88.204 L28.681,86.052 L28.681,81.399 L39.624,75.179 L39.624,66.499 L31.685,71.601 L31.685,62.405 L24.096,66.779 L24.096,79.247 L19.945,81.819 L16.437,79.498 L16.437,71.142 L4.919,77.64 L0,75.57 L0,70.3 L12.089,63.691 L4.528,59.89 L4.528,55.068 L8.819,52.719 L19.664,59.105 L27.197,54.759 L27.015,54.62 L19.314,50.203 L26.791,45.563 L19.286,41.217 L8.442,47.589 L4.374,45.563 L4.374,40.755 L11.713,36.632 L0,30.272 L0,25.003 L4.5,22.684 L16.044,29.35 L16.044,20.853 L19.524,18.505 L23.788,20.965 L23.76,33.683 L31.516,38.113 L31.489,29.127 L39.623,33.502 L39.623,24.822 L28.68,18.589 L28.68,13.977 L32.439,11.797 L39.818,15.948 L39.818,2.768 L44.04,0 L48.301,2.768 L48.301,15.948 L55.947,11.713 L59.792,14.257 L59.792,18.408 L48.47,24.822 L48.47,33.502 L56.214,28.778 L56.214,38.226 L64.193,33.878 L64.193,20.28 L68.037,18.491 L72.075,20.28 L72.075,28.974 L83.954,22.558 L88.107,25.088 L88.107,30.007 L76.506,36.604 L83.76,40.67 L83.76,45.367 L80,47.45 L68.862,40.867 L61.16,45.759 L68.609,50.401 L60.936,54.817 L68.862,58.967 L80,52.746 L83.578,55.276 L83.578,59.763 L76.59,63.69 L87.716,70.3 L87.716,75.488 L83.006,77.64 L72.075,71.419 L72.075,79.651 L68.148,81.845 L64.305,79.651 L64.305,67.155 L56.213,62.544 L56.213,71.224 L48.469,66.499 L48.469,75.179 L59.413,81.399 L59.413,86.319 L55.637,88.205 L48.3,84.055 L48.3,97.262 L44.04,100 L39.819,97.261 L39.819,97.261 Z" id="Shape" sketch:type="MSShapeGroup"></path></g></g></svg>';

        // Create a Data URI.
        var snowSrc = 'data:image/svg+xml;base64,' + window.btoa(snowSvg);

        // Load up our image.
        var snowSource = new Image();
        snowSource.src = snowSrc;

        var snowArray = [],
            maxSpeed = 2,
            spacing = 50,
            xSpacing = 0,
            n = innerWidth / spacing,
            sizes = [[39, 30], [20, 20.18], [10, 10.65]],
            i;

        for (i = 0; i < n; i++) {
            for (x = 0; x < sizes.length; x++) {
                xSpacing += spacing;
                snowArray.push({
                    x: Math.round(Math.random() * c.weatherCanvas.width),
                    y: Math.round(Math.random() * c.weatherCanvas.height),
                    width: 2,
                    height: Math.round(Math.random() * (innerHeight / 10)),
                    speed: Math.random() * maxSpeed + 1,
                    imgWidth: sizes[x][0],
                    imgHeight: sizes[x][1],
                    img: snowSource
                });
            }
        }

        function draw() {
            var i;
            c.weatherCTX.clearRect(0, 0, c.weatherCanvas.width, c.weatherCanvas.height);
            for (i = 0; i < n; i++) {
                c.weatherCTX.drawImage(snowArray[i].img, snowArray[i].x, snowArray[i].y, snowArray[i].imgWidth, snowArray[i].imgHeight);
                snowArray[i].y += snowArray[i].speed;
                snowArray[i].x = snowArray[i].x + 1;

                if (snowArray[i].y > c.weatherCanvas.height) {
                    snowArray[i].y = 0 - snowArray[i].height;
                    snowArray[i].x = Math.random() * c.weatherCanvas.width;
                }

                if (snowArray[i].x > c.weatherCanvas.width)
                    snowArray[i].x = 0 - 100;
            }

            c.requestWeather = requestAnimationFrame(draw);

        }
        draw();
    },

    animateLightning: function () {
        var lightningSVG = '<svg width="165px" height="478px" viewBox="0 0 165 478" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:sketch="http://www.bohemiancoding.com/sketch/ns"><title>Shape</title><desc>Created with Sketch.</desc><defs></defs><g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd" sketch:type="MSPage"><path d="M100.879903,-8.99765934 L90.162516,133.004374 L100.879903,133.004374 L64.9851657,491.002341 L79.4836165,214.81442 L63.3793211,214.814428 L85.7571545,-8.99765934 L100.879903,-8.99765934 Z" id="Shape" fill="#FFFFFF" sketch:type="MSShapeGroup" transform="translate(82.129612, 241.002341) rotate(15.000000) translate(-82.129612, -241.002341) "></path></g></svg>';

        // Create a Data URI.
        var lightningSrc = 'data:image/svg+xml;base64,' + window.btoa(lightningSVG);

        // Load up our image.
        var lightningIMG = new Image();
        lightningIMG.src = lightningSrc;

        thunderDraw();




        function thunderDraw() {
            var i;
            c.lightningCTX.clearRect(0, 0, c.lightningCanvas.width, c.lightningCanvas.height);

            function flash() {

                c.lightningCTX.fillStyle = 'rgba(255,255,255,.6)';
                c.lightningCTX.fillRect(0, 0, c.lightningCanvas.width, c.lightningCanvas.height);

                var locx = Math.random() * (c.lightningCanvas.width - 165);
                var locy = Math.random() * (c.lightningCanvas.height - 478);
                c.lightningCTX.drawImage(lightningIMG, locx, locy);



                function flashOff() {
                    c.lightningCTX.clearRect(0, 0, c.lightningCanvas.width, c.lightningCanvas.height);
                }

                setInterval(flashOff, 25);

            }

            c.refreshIntervalID = setInterval(flash, 2000);

        }
    }

};
if ('1' == UseWeather) {
    var supportsPointerEvents = (function () {
        var dummy = document.createElement('_');
        if (!('pointerEvents' in dummy.style)) return false;
        dummy.style.pointerEvents = 'auto';
        dummy.style.pointerEvents = 'x';
        document.body.appendChild(dummy);
        var r = getComputedStyle(dummy).pointerEvents === 'auto';
        document.body.removeChild(dummy);
        return r;
    })();
    if (!supportsPointerEvents) {
        $(document).mouseup(function (e) {
            e = e || window.event;
            var x = e.clientX;
            var y = e.clientY;
            $("#weather-background").hide();
            var dd = document.elementFromPoint(x, y);
            $("#weather-background").show();
            if ("text" == dd.type || "password" == dd.type) {
                var t = dd.value;
                dd.value = "";
                dd.focus();
                dd.value = t;
            }
            dd.click();
        });
    }
    //    var myCity = new BMap.LocalCity(), wType = '';
    //    myCity.get(myFun);
    //实例化城市查询类
    var citysearch = new AMap.CitySearch();
    //自动获取用户IP，返回当前城市
    citysearch.getLocalCity(function (status, result) {
        if (status === 'complete' && result.info === 'OK') {
            if (result && result.city && result.bounds) {
                var cityinfo = result.city; //取得当前城市
                if (cityinfo != "")//定位不到城市，天气不显示
                {
                    wSearch(cityinfo);
                }
            }
        }
    });
}
else {
    $("#weather-background").hide();
}

function myFun(result) {
    var cityName = "";
    if (result) {
        if (result.name.substr(result.name.length - 1) == "市")
            cityName = result.name.substr(0, result.name.length - 1);
        else
            cityName = result.name; //alert(JSON.stringify( result ) );
        wSearch(cityName);
    }
    else {
        myCity.get(myFun);
    }
}

function wSearch(cityName) {
    if (cityName != "") {
        $.ajax({
            url: "http://wthrcdn.etouch.cn/weather_mini?city=" + encodeURI(cityName),
            crossDomain: true,
            success: function (msg) {
                //alert( msg.toString() );
                var weather = $.parseJSON(msg); //alert( JSON.stringify( weather ) );
                if ("OK" == weather.desc) {
                    wType = weather.data.forecast[0].type;
                    CanvasBackground.init(wChoose(wType)); //绑定天气特效
                    //CanvasBackground.init("snow"); //测试特效雪:snow,雨:rain,晴:sun,多云:sunClouds
                }
                else {
                    myCity.get(myFun);
                }
            },
            error: function (XMLHttpRequest, textStatus, errorThrown) {
                //alert( "获取天气请求失败，错误："+ XMLHttpRequest.status + "," + XMLHttpRequest.readyState + textStatus + "  " + errorThrown );
                wSearch(cityName);
            }
        });
    }
}
/*
阴:clouds,雪:snow,雨:rain,
晴:sun,多云:sunClouds,毛毛雨:smallRain,
雷雨:Thunderstorm,
*/
function wChoose(type) {
    if (type.length > 0) {
        if (type.indexOf("雨") != -1 || type.indexOf("冰") != -1) {
            if (type.indexOf("雷") != -1) {
                return "Thunderstorm";
            }
            else if (type.indexOf("小") != -1) {
                return "smallRain";
            }
            else {
                return "rain";
            }
        }
        else {
            if (type.indexOf("雪") != -1) {
                return "snow";
            }
            else {
                if (type.indexOf("阴") != -1) {
                    return "clouds";
                }
                else {
                    if (type.indexOf("多云") != -1) {
                        return "sunClouds";
                    }
                    else {

                        return "sun";
                    }
                }
            }

        }
    }
    else {
        return "";
    }
}
//$(function() {
//    CanvasBackground.init();
//});
